<?php

class live_editor extends cmsFrontend {
	
	public function actionUpload(){
		
		if (!cmsUser::isLogged()) { cmsCore::error404(); }
		
        if(!$this->request->hasInQuery('img')){$allowed_extensions = 'jpg,jpeg,png,gif,bmp,swf,zip,rar,pdf,xlsx,xls,doc,docx,txt,rtf,csv';}
        
		if ($this->request->has('submit')){
            if($this->request->hasInQuery('img')){
                $this->uploadImage();
            }else{
                $this->uploadFile($allowed_extensions);
            }
		}
		
		$template = cmsTemplate::getInstance();
        
        if($this->request->hasInQuery('img')){
            $images_controller = cmsCore::getController('images');
            $html = $template->render('upload', array(
                'allowed_extensions' => $images_controller->getAllowedExtensions()
            ));
        }else{
            $html = $template->render('upload', array(
                
                'allowed_extensions' => $allowed_extensions
            ));
        }
        
		
		echo $html; $this->halt();
		
	}
	
	public function uploadImage(){
		
		$template = cmsTemplate::getInstance();

		$csrf_token = $this->request->get('csrf_token');
		
		if (!cmsForm::validateCSRFToken($csrf_token)){

            $html = $template->render('upload', array(
                'allowed_extensions' => $this->allowed_extensions,				
                'error' => LANG_FORM_ERRORS
            ));

            echo $html; $this->halt();
			
		}

		$images_controller = cmsCore::getController('images');
		
		$result = $images_controller->uploadWithPreset('image', 'wysiwyg_live');
		
        if (!$result['success']){

            $html = $template->render('upload', array(
                'allowed_extensions' => $images_controller->getAllowedExtensions(),				
                'error' => $result['error']
            ));

            echo $html; $this->halt();

        }

        $html = $template->render('image', array(
            'url' => $result['image']['url']
        ));

        echo $html; $this->halt();
		
	}
	
	public function uploadFile($allowed_extensions){
		
		$template = cmsTemplate::getInstance();

		$csrf_token = $this->request->get('csrf_token');
		
		if (!cmsForm::validateCSRFToken($csrf_token)){

            $html = $template->render('upload', array(
                'allowed_extensions' => $allowed_extensions,
                'error' => LANG_FORM_ERRORS
            ));

            echo $html; $this->halt();
			
		}
		
		$result = $this->uploadFileGo($allowed_extensions);
		
        if (!$result['success']){

            $html = $template->render('upload', array(
                'allowed_extensions' => $allowed_extensions,				
                'error' => $result['error']
            ));

            echo $html; $this->halt();

        }

        $html = $template->render('file', array(
            'name'  => $result['name'],
            'url'  => '/upload/' . $result['url']
        ));

        echo $html; $this->halt();
		
	}
    
    public function uploadFileGo($allowed_extensions){
        
        $max_size_mb = 50 * 1048576;
        $path_to = 'live';
    
        $uploader = new cmsUploader();

        $result = $uploader->uploadForm('file', $allowed_extensions, $max_size_mb, $path_to);

        return $result;
		
    }
	
}
